#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
int brojevi[40];
int main(){
    ios_base::sync_with_stdio(false);cin.tie(0);
    int n;cin>>n;
    int niz[n];
    for(int i=0;i<n;i++){
        cin>>niz[i];
        for(int j=0;j<=32;j++){
            if(niz[i]&(1<<j))brojevi[j]++;
        }
    }
    /*for(int i=0;i<32;i++){
        cout<<brojevi[i]<<" ";
    }*/
    int q=1;cin>>q;
    while(q--){
        int t;cin>>t;
        if(t==1){
            int k,x;
            cin >> k >> x;
            k--;
            //smanji za niz[k] i povecaj za x
            for(int i=0;i<32;i++){
                if(niz[k]&(1<<i))brojevi[i]--;
                if(x&(1<<i))brojevi[i]++;
            }
            niz[k]=x;
        }
        else{
            int k,broj=0;
            cin>>k;
            for(int i=0;i<32;i++){
                //cout<<brojevi[i]<<" ";
                if(brojevi[i]>=k){
                    //cout<<(1<<i)<< endl;
                    broj+=(1<<i);
                }
            }//cout<<endl;
            cout<<broj<<endl;
        }
    }
    return 0;

}